// $$PROJECT$$.c:  Get a message from a queue
//
#include <stdio.h>
#include <string.h>
#include <cmqc.h>

#define CHECKRC(text, iReason) \
	if (iReason != 0) \
	{ \
		printf("Failed: %s: %d\n", text, iReason); \
		return(1); \
	}

int main(int argc, char* argv[])
{
	char	*qName;
	char	*qMgrName;
	char	buffer[256];

	MQLONG	iCompCode;
	MQLONG	iReason;
	MQLONG	iLength;

	MQHCONN	hConn;
	MQOD	myOD = {MQOD_DEFAULT};
	MQMD	myMD = {MQMD_DEFAULT};
	MQGMO	myGMO = {MQGMO_DEFAULT};
	MQHOBJ	hQueue;


	if (argc < 3)
	{
		printf("Usage: $$PROJECR$$ QName QMgrName\n");
		return(1);
	}
	qName		= argv[1];
	qMgrName	= argv[2];

	MQCONN(qMgrName, &hConn, &iCompCode, &iReason);
	CHECKRC("MQCONN", iReason);

	strncpy(myOD.ObjectName, qName, 48);

	MQOPEN(hConn, &myOD, MQOO_INPUT_AS_Q_DEF, &hQueue, &iCompCode, &iReason);
	CHECKRC("MQOPEN", iReason);

	myGMO.WaitInterval = 10 * 1000;
	myGMO.Options = MQGMO_WAIT;

	MQGET(hConn, hQueue, &myMD, &myGMO, sizeof(buffer),
		  buffer, &iLength, &iCompCode, &iReason);
	CHECKRC("MQGET", iReason);

	printf("<%.*s>\n", iLength, buffer);

	MQCLOSE(hConn, &hQueue, MQCO_NONE, &iCompCode, &iReason);
	MQDISC(&hConn, &iCompCode, &iReason);
	return(0);
}
